// About.cpp

#include "stdafx.h"
#include "Resource.h"
#include "About.h"
#include <Math.h>

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_ICON1, m_wndIcon);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_hicon = m_wndIcon.GetIcon();
	m_wndIcon.GetWindowRect(m_rectIcon);
	ScreenToClient(m_rectIcon);
	m_wndIcon.ShowWindow(SW_HIDE);

	int x = m_rectIcon.Width();
	int y = m_rectIcon.Height();
	int r = int(sqrt(x * x + y * y));
	m_rectBuffer = m_rectIcon;
	m_rectBuffer.InflateRect((r - x)/2, (r - y)/2);

	CClientDC dc(this);
	m_dcIcon.CreateCompatibleDC(&dc);
	m_dcBuffer.CreateCompatibleDC(&dc);
	m_bmImage.CreateCompatibleBitmap(&dc, m_rectIcon.Width(), m_rectIcon.Height());
	m_bmBuffer.CreateCompatibleBitmap(&dc, m_rectBuffer.Width(), m_rectBuffer.Height());
	CBitmap* pBmOld = m_dcIcon.SelectObject(&m_bmImage);
	FillRect(m_dcIcon, CRect(CPoint(0, 0), m_rectIcon.Size()), GetSysColorBrush(COLOR_3DFACE));
	m_dcIcon.DrawIcon(0, 0, m_hicon);
	m_dcIcon.SelectObject(pBmOld);

	SetTimer(1, 10, NULL);

	return TRUE;
}

void CAboutDlg::OnTimer(UINT nIDEvent) 
{
	const double Pi = 3.1415;
	static double theta = 0;

	CPoint ptCenter = m_rectBuffer.CenterPoint() - m_rectBuffer.TopLeft();
	CPoint ptRadius = m_rectIcon.CenterPoint() - m_rectIcon.TopLeft();
	double r = sqrt(ptRadius.x * ptRadius.x + ptRadius.y * ptRadius.y);

	CClientDC dc(this);
	CBitmap* pBmOld = m_dcBuffer.SelectObject(&m_bmBuffer);
	CBitmap* pBmOld2 = m_dcIcon.SelectObject(&m_bmImage);
	CPoint rgpt[3] = {
		CPoint(int(r * sin(-theta)), int(r * cos(-theta))),
		CPoint(int(r * sin(-theta - Pi/2)), int(r * cos(-theta - Pi/2))),
		CPoint(int(r * sin(-theta + Pi/2)), int(r * cos(-theta + Pi/2)))
	};
	for (int i = 0; i < 3; i++)
		rgpt[i] += ptCenter;

	FillRect(m_dcBuffer, CRect(CPoint(0, 0), m_rectBuffer.Size()),
		GetSysColorBrush(COLOR_3DFACE));
	if (PlgBlt(m_dcBuffer, rgpt, m_dcIcon, 0, 0, m_rectIcon.Width(), m_rectIcon.Height(),
		NULL, 0, 0))
	{
		BitBlt(dc, m_rectBuffer.left, m_rectBuffer.top, 
			m_rectBuffer.Width(), m_rectBuffer.Height(),
			m_dcBuffer, 0, 0, SRCCOPY);
	}
	else
	{
		m_wndIcon.ShowWindow(SW_SHOW);
		KillTimer(1);
	}

	m_dcBuffer.SelectObject(pBmOld);
	m_dcIcon.SelectObject(pBmOld2);

	theta += Pi/90;
	if (theta > 2 * Pi)
		theta -= 2 * Pi;
}
