// ClipSpyDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CClipSpyDlg dialog

class CClipSpyDlg : public CDialog, public CPersistence
{
// Construction
public:
	CClipSpyDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CClipSpyDlg)
	enum { IDD = IDD_MAIN };
	CListCtrl	m_wndList;
	CStatic	m_wndText1;
	CButton	m_wndClose;
	CButton	m_wndRefresh;
	CButton	m_wndUseOle;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClipSpyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CClipSpyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnDrawClipboard();
	afx_msg void OnChangeCbChain(HWND hWndRemove, HWND hWndAfter);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnBegindragList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnButton1();
	afx_msg void OnCheckOleClipboard();
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	virtual void OnExchangePersistentData();

private:
	void SetTopMost(BOOL fTopMost);
	void SetColumns(BOOL fShowTymed);
	void Refresh();
	BOOL SaveClipboardData(UINT nFormat, const CString& strFile);
	BOOL SaveClipboardDataToTempFile(UINT nFormat, CString& strTempFile);

private:
	// MFC does not support MI, so we must use an embedded COleDropTarget
	template <typename T>
	class DropTarget : public COleDropTarget
	{
		typedef DropTarget<T> self;
	public:
		self(T& outer_) : outer(outer_) {}
		DROPEFFECT OnDragEnter(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
			{ return outer.OnDragEnter(pWnd, pDataObject, dwKeyState, point); }
		DROPEFFECT OnDragOver(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
			{ return outer.OnDragOver(pWnd, pDataObject, dwKeyState, point); }
		void OnDragLeave(CWnd* pWnd)
			{ outer.OnDragLeave(pWnd); }
		BOOL OnDrop(CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point)
			{ return outer.OnDrop(pWnd, pDataObject, dropEffect, point); }
	private:
		T& outer;
	};
	DropTarget<CClipSpyDlg> m_dropTarget;
	COleDataObject* m_pDataObject;

public:
	// The real handlers
	DROPEFFECT OnDragEnter(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	DROPEFFECT OnDragOver(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	void OnDragLeave(CWnd* pWnd);
	BOOL OnDrop(CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);

private:
	CCommandMenu m_menuSystem;
	BOOL m_fAlwaysOnTop;
	BOOL m_fUseOleClipboard;
	CPoint m_ptMinSize;
	CSize m_posList;
	CSize m_posRefresh;
	CSize m_posClose;
	CSize m_posUseOle;
	BOOL m_fDoneInitDialog;
	HWND m_hwndClipChainNext;
	CArray<int, int> m_formats;
	CImageList m_imagelist;
	CStringList m_listTempFiles;
};
